package com.jnbridge.adapters.oaq;

import java.util.Hashtable;
import java.util.Properties;


import javax.naming.Binding;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.NameClassPair;
import javax.naming.NameParser;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import oracle.AQ.*;
import oracle.jms.*;
import javax.jms.*;

public class OAQContext implements Context {
	
	private String hostname = null;
	private String sid = null;
	private String username = null;
	private String password = null;
	private int port = 0;
	
	public OAQContext(String host, String username, String password, String sid, int port)
	{
		this.hostname = host;
		this.username = username;
		this.password = password;
		this.sid = sid;
		this.port = port;
	}
	
	private ConnectionFactory getCF(String name) throws NamingException
	{
		ConnectionFactory cf = null;
		Properties creds = new Properties();
		creds.put(username, password);
		try
		{
			if (name.equalsIgnoreCase("QueueConnectionFactory"))
			{
				cf = AQjmsFactory.getQueueConnectionFactory(this.hostname, this.sid, this.port, "thin" );
			}
			else if (name.equalsIgnoreCase("TopicConnectionFactory"))
			{
				cf = AQjmsFactory.getTopicConnectionFactory(this.hostname, this.sid, this.port, "thin" );
			}
			else
			{
				cf = AQjmsFactory.getConnectionFactory(this.hostname, this.sid, this.port, "thin" );
			}
		}
		catch (Exception ex)
		{
			throw new NamingException("Unable to get OAQ connection factory: " + ex.getMessage()); 
		}
		
		return cf;
	}

	public Object addToEnvironment(String propName, Object propVal)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public void bind(Name name, Object obj) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void bind(String name, Object obj) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void close() throws NamingException {
		// TODO Auto-generated method stub

	}

	public Name composeName(Name name, Name prefix) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public String composeName(String name, String prefix)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public Context createSubcontext(Name name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public Context createSubcontext(String name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public void destroySubcontext(Name name) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void destroySubcontext(String name) throws NamingException {
		// TODO Auto-generated method stub

	}

	public Hashtable<?, ?> getEnvironment() throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public String getNameInNamespace() throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NameParser getNameParser(Name name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NameParser getNameParser(String name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NamingEnumeration<NameClassPair> list(Name name)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NamingEnumeration<NameClassPair> list(String name)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NamingEnumeration<Binding> listBindings(Name name)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public NamingEnumeration<Binding> listBindings(String name)
			throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public Object lookup(Name name) throws NamingException {
		
		return null;
	}

	public Object lookup(String name) throws NamingException {
		
		ConnectionFactory cf = null;
		Connection connection = null;
		Session session = null;
		Object rtn = null;
		cf = this.getCF(name);
		if (name.equalsIgnoreCase("QueueConnectionFactory") || name.equalsIgnoreCase("TopicConnectionFactory"))
		{
			rtn = cf;
		}
		else 
		{
			try 
			{
				connection = cf.createConnection(this.username, this.password);
				session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);			
			} 
			catch (Exception ex) 
			{
				throw new NamingException("Unable to create a connection and session: " + ex.getMessage());
			}
			try
			{
				Queue q = ((AQjmsSession)session).getQueue(this.username, name);
				rtn = q;
			}
			catch(Exception ex)
			{
				
			}
			if( rtn == null)
			{
				try
				{
					Topic t = ((AQjmsSession)session).getTopic(this.username, name);
					rtn = t;
				}
				catch(Exception ex)
				{
					
				}
			}
			
		}
		if( session != null)
		{
			try {
				session.close();
			} catch (JMSException e) {
				
			}
		}
		if ( connection != null)
		{
			try {
				connection.close();
			} catch (JMSException e) {
				
			}
		}
		
		if (rtn == null)
		{
			throw new NamingException("Unable to find object: " + name);
		}
		return rtn;
	}

	public Object lookupLink(Name name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public Object lookupLink(String name) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public void rebind(Name name, Object obj) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void rebind(String name, Object obj) throws NamingException {
		// TODO Auto-generated method stub

	}

	public Object removeFromEnvironment(String propName) throws NamingException {
		// TODO Auto-generated method stub
		return null;
	}

	public void rename(Name oldName, Name newName) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void rename(String oldName, String newName) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void unbind(Name name) throws NamingException {
		// TODO Auto-generated method stub

	}

	public void unbind(String name) throws NamingException {
		// TODO Auto-generated method stub

	}

}
